import random

import numpy

from algorithm.decision_tree.decision_tree import DecisionTree
from aufgaben.p4.testdata import get_labeled_testdata
from aufgaben.p6.multiclass_error_rate import Multiclass_ErrorRate


def apply_decision_tree():
    test_data, training_data = get_labeled_testdata()

    # Trainiere den Decision Tree
    algorithm = DecisionTree(entropy_threshold=0.5, number_segments=10, print_after_train=True)
    algorithm.train(None, training_data)

    # Vergleiche alle Ergebnisse mit der erwarteten Klasse
    fehlerrate = Multiclass_ErrorRate()
    for features, correct_class in test_data:
        result = algorithm.classify(features)
        fehlerrate.evaluate(correct_class, result)
    fehlerrate.print_table()


if __name__ == '__main__':
    apply_decision_tree()
